// La maggior parte di questo codice opera di Marcello "John Doe" Puri
//
// Revisioni:
// - 04/04/2023 Marcello "John Doe" Puri
//   Inserito in jdFantaBlu2 v2.3.0.
//   Corretta generazione delle sezioni Storico e Dettagliato che in alcune circostanze
//   (lega o competizioni non giocate in alcuni anni) non venivano compilati correttamente.
//   Revisione ed ottimizzazione generale del codice.
// - 31/05/2023 Marcello "John Doe" Puri
//   Corretta visualizzazione della sezione Piazzamenti
//   Inserito in jdFantaBlu2 v2.4.0.

// Oggetto Competizione Albo dOro
function AdOC(ID, idAttuale, nome, iniziataNel) {
	this.ID = ID
	this.idAttuale = idAttuale
	this.nome = nome
	this.iniziataNel = iniziataNel
}

// Oggetto Fantasquadra Albo d'Oro
function AdOF(ID, idAttuale, nome, iniziataNel) {
	this.ID = ID
	this.idAttuale = idAttuale
	this.nome = nome
	this.iniziataNel = iniziataNel
}

// Oggetto Posizione Albo dOro
function AdOP(idCompetizione, idSquadra, anno, stagione, posizione, presidente, punti, note) {
	this.idCompetizione = idCompetizione
	this.idSquadra = idSquadra
	this.anno = anno
	this.stagione = stagione
	this.posizione = posizione
	this.presidente = presidente
	this.punti = punti
	this.note = note
}

// Tabelle corrispondenza per competizioni e fantasquadre (da ID a indice on arrAdO*)
var mapCompetizioni = new Array()
var mapFantasquadre = new Array()

function generaTabelleCorrispondenza() {
	var i
	for (i = 1; i < arrAdOCompetizioni.length; i++)
		mapCompetizioni[arrAdOCompetizioni[i].ID] = i
	for (i = 1; i < arrAdOFantasquadre.length; i++)
		mapFantasquadre[arrAdOFantasquadre[i].ID] = i
}

function GeneraVittorie()
{
	function V(idSquadra, nome, idAttuale) {
		this.idSquadra = idSquadra
		this.nome = nome
		this.idAttuale = idAttuale
		this.vittorie = new Array(nComp + 1)
		for (var c = 1; c < this.vittorie.length; c++)
			this.vittorie[c] = 0
	}
	function ordina(a, b) {
		for (var c = 1; c < arrAdOCompetizioni.length; c++) {
			if (a.vittorie[c] < b.vittorie[c]) return 1
			if (a.vittorie[c] > b.vittorie[c]) return -1
		}
		return a.nome > b.nome ? 1 : -1
	}

	// Genera tabelle corrispondeza per competizioni e fantasquadre
	generaTabelleCorrispondenza()

	var nComp = arrAdOCompetizioni.length - 1
	var vittorie = new Array()
	var c, f, p, v, cnt

	var tabV = new Tabella(2, nComp + 1)

	// Imposta propriet della tabella
	tabV.nome = "Vittorie albo d'oro"
	tabV.larghezza = 100
	tabV.border = 0
	tabV.cellpadding = 1
	tabV.cellspacing = 0
	tabV.stile = "ClassEl"
	tabV.SetLarghezzaColonna(1, 30)
	for (c = 1; c <= nComp; c++)
		tabV.SetLarghezzaColonna(c + 1, 70 / nComp)

	// Imposta stile header
	tabV.SetStileRiga(1, "IntRossoBlu")

	// Imposta stile celle dell'header
	for (c = 1; c <= nComp; c++)
		tabV.SetStile(1, c + 1, "Cella")

	// Imposta valori celle dell'header
	tabV.SetValore(1, 1, "Squadra")
	for (c = 1; c <= nComp; c++)
		tabV.SetValore(1, c + 1, arrAdOCompetizioni[c].nome)

	// Calcola vittorie di ogni squadra
	for (f = 1; f < arrAdOFantasquadre.length; f++)
		vittorie[f] = new V(arrAdOFantasquadre[f].ID, arrAdOFantasquadre[f].nome, arrAdOFantasquadre[f].idAttuale)
	for (p = 1; p < arrAdOPosizioni.length; p++)
		if (arrAdOPosizioni[p].posizione == 1) {
			var idxC = mapCompetizioni[arrAdOPosizioni[p].idCompetizione]
			var idxF = mapFantasquadre[arrAdOPosizioni[p].idSquadra]
			vittorie[idxF].vittorie[idxC]++;
		}
	// E le ordina
	vittorie.sort(ordina)

	// Riempie la tabella
	cnt = 2
	for (v = 0; v < vittorie.length - 1; v++) {
		// Imposta stile della riga
		tabV.SetStileRiga(cnt, cnt % 2 == 0 ? "AlboD" : "AlboP")
		// Imposta stile e valore della cella 'squadra'
		tabV.SetStile(cnt, 1, vittorie[v].idAttuale == 0 ? "Cella" : "CellaBold")
		tabV.SetValore(cnt, 1, vittorie[v].nome)
		// Imposta stile e valore delle celle 'vittorie'
		for (c = 1; c < vittorie[v].vittorie.length; c++) {
			tabV.SetStile(cnt, c + 1, "CellaCentro")
			if (vittorie[v].vittorie[c] != 0)
				tabV.SetValore(cnt, c + 1, vittorie[v].vittorie[c])
		}
		cnt++;
	}
	// E la stampa
	tabV.Stampa()
}

function GeneraPiazzamenti()
{
	function P(idSquadra, nome, idAttuale) {
		this.idSquadra = idSquadra
		this.nome = nome
		this.idAttuale = idAttuale
		this.piazzamenti = new Array(nComp + 1)
		for (var c = 1; c < arrAdOCompetizioni.length; c++)
			this.piazzamenti[c] = new Array()
	}
	function ordina(a, b) {
		return a.nome > b.nome ? 1 : -1
	}

	var nComp = arrAdOCompetizioni.length - 1
	var piazzamenti = new Array()
	var c, f, p, i, cnt

	var tabP = new Tabella(2, nComp + 1)

	// Imposta propriet della tabella
	tabP.nome = "Piazzamenti albo d'oro"
	tabP.larghezza = 100
	tabP.border = 0
	tabP.cellpadding = 1
	tabP.cellspacing = 0
	tabP.stile = "ClassEl"
	tabP.SetLarghezzaColonna(1, 30)
	for (c = 1; c <= nComp; c++)
		tabP.SetLarghezzaColonna(c + 1, 70 / nComp)

	// Imposta stile header
	tabP.SetStileRiga(1, "IntRossoBlu");

	// Imposta stile celle dell'header
	for (c = 1; c <= nComp; c++)
		tabP.SetStile(1, c + 1, "Cella")

	// Imposta valori celle dell'header
	tabP.SetValore(1, 1, "Squadra")
	for (c = 1; c <= nComp; c++)
		tabP.SetValore(1, c + 1, arrAdOCompetizioni[c].nome)

	// Calcola piazzamenti di ogni squadra
	for (f = 1; f < arrAdOFantasquadre.length; f++)
		piazzamenti[f] = new P(arrAdOFantasquadre[f].ID, arrAdOFantasquadre[f].nome, arrAdOFantasquadre[f].idAttuale)
	for (p = 1; p < arrAdOPosizioni.length; p++) {
		var idxC = mapCompetizioni[arrAdOPosizioni[p].idCompetizione]
		var idxF = mapFantasquadre[arrAdOPosizioni[p].idSquadra]
		if (piazzamenti[idxF].piazzamenti[idxC][arrAdOPosizioni[p].posizione] == undefined)
			piazzamenti[idxF].piazzamenti[idxC][arrAdOPosizioni[p].posizione] = 0
		piazzamenti[idxF].piazzamenti[idxC][arrAdOPosizioni[p].posizione]++
	}
	// E le ordina
	piazzamenti.sort(ordina)

	// Riempie la tabella
	cnt = 2
	for (p = 0; p < piazzamenti.length - 1; p++) {
		// Imposta stile della riga
		tabP.SetStileRiga(cnt, cnt % 2 == 0 ? "AlboD" : "AlboP")
		// Imposta stile e valore della cella 'squadra'
		tabP.SetStile(cnt, 1, piazzamenti[p].idAttuale == 0 ? "Cella" : "cellaVold")
		tabP.SetValore(cnt, 1, "<span class='" + (piazzamenti[p].idAttuale == 0 ? "t-xxsV" : "t-xxsVB") +"'>" + piazzamenti[p].nome +"</span>")
		// Imposta stile e valore delle celle 'piazzamenti'
		for (c = 1; c < piazzamenti[p].piazzamenti.length; c++) {
			tabP.SetStile(cnt, c + 1, "CellaCentro")
			var valoriCella = new Array()
			for (i = 1; i < piazzamenti[p].piazzamenti[c].length; i++) {
				var pp = piazzamenti[p].piazzamenti[c][i]
				if (pp != undefined) {
					v = String(i) + "&deg;"
					if (pp > 1) v += " [" + pp + "]"
					valoriCella.push(v)
				}
			}
			if (valoriCella.length > 0)
				tabP.SetValore(cnt, c + 1, valoriCella.join(", "))
		}
		cnt++
	}
	// E la stampa
	tabP.Stampa()
}

function GeneraStorico()
{
	function S(idSquadra, nome, idAttuale) {
		this.idSquadra = idSquadra
		this.nome = nome
		this.idAttuale = idAttuale
		this.storico = new Array(nAnni)
	}
	function ordina(a, b) {
		return a.nome > b.nome ? 1 : -1
	}

	// Determina anni in cui si sono svolte le competizioni
	var arrAnni = determinaAnniCompetizione(-1)
	var nAnni = arrAnni.length

	var nComp = arrAdOCompetizioni.length - 1
	var c, f, p, a, s, cnt
	var storico

	// Genera una tabella per ogni competizione
	for (c = 1; c <= nComp; c++) {
		// Calcola storico della competizione
		storico = new Array()
		for (f = 1; f < arrAdOFantasquadre.length; f++)
			storico[f] = new S(arrAdOFantasquadre[f].ID, arrAdOFantasquadre[f].nome, arrAdOFantasquadre[f].idAttuale)
		for (p = 1; p < arrAdOPosizioni.length; p++)
			if (arrAdOPosizioni[p].idCompetizione == arrAdOCompetizioni[c].ID) {
				var idxF = mapFantasquadre[arrAdOPosizioni[p].idSquadra]
				var idxA = arrAnni.indexOf(arrAdOPosizioni[p].anno)
				storico[idxF].storico[idxA] = arrAdOPosizioni[p].posizione
			}
		// E lo ordina
		storico.sort(ordina)

		var tabS = new Tabella(2, nAnni + 1)

		// Imposta propriet della tabella
		tabS.nome = "Storico albo d'oro"
		tabS.larghezza = 100
		tabS.border = 0
		tabS.cellpadding = 1
		tabS.cellspacing = 0
		tabS.stile = "ClassEl"
		tabS.SetLarghezzaColonna(1, 30)
		for (a = 0; a < nAnni; a++)
			tabS.SetLarghezzaColonna(a + 2, 70 / nAnni)

		// Imposta propriet e contenuto del titolo (nome della competizione)
		tabS.SetStileRiga(1, "IntRossoBlu")
		tabS.SetSpan(1, 1, nAnni + 1)
		for (a = 0; a < nAnni; a++)
			tabS.SetSpanned(1, a + 2, true)
		tabS.SetValore(1, 1, arrAdOCompetizioni[c].nome)

		// Imposta stile e contenuto dell'header
		tabS.SetStileRiga(2, "IntRossoBlu")
		for (a = 0; a < nAnni; a++)
			tabS.SetStile(2, a + 2, "Cella")
		tabS.SetValore(2, 1, "Squadra")
		for (a = 0; a < nAnni; a++)
			tabS.SetValore(2, a + 2, arrAnni[a])

		// Riempie la tabella
		cnt = 3
		for (s = 0; s < storico.length - 1; s++) {
			// Imposta stile della riga
			tabS.SetStileRiga(cnt, cnt % 2 == 0 ? "AlboD" : "AlboP")

			// Imposta stile e valore della cella 'squadra'
			tabS.SetStile(cnt, 1, storico[s].idAttuale == 0 ? "Cella" : "CellaBold")
			tabS.SetValore(cnt, 1, "<span class='" + (storico[s].idAttuale == 0 ? "t-xxsR" : "t-xxsRB") + "'>" + storico[s].nome + "</span>")

			// Imposta stile e valore delle celle 'storico'
			for (a = 0; a < nAnni; a++) {
				tabS.SetStile(cnt, a + 2, "testo-10")
				if (storico[s].storico[a] != undefined)
					tabS.SetValore(cnt, a + 2, storico[s].storico[a])
			}
			cnt++
		}
		// E la stampa
		tabS.Stampa()
		if (c != nComp) document.write("<br>")
	}
}

function determinaAnniCompetizione(idCompetizione) {
	var aux = new Array(), anni = new Array()

	for (var p = 1; p < arrAdOPosizioni.length; p++)
		if (idCompetizione == -1 || idCompetizione == arrAdOPosizioni[p].idCompetizione)
			aux.push(arrAdOPosizioni[p].anno)
	aux.sort()

	anni[0] = aux[0];
	for (var a = 0; a < aux.length - 1; a++)
		if (aux[a] != aux[a + 1])
			anni.push(aux[a + 1])

	return anni
}

function GeneraDettagliato()
{
	function ordina(a, b) {
		return a.posizione - b.posizione
	}

	// Determina anni in cui si sono svolte le competizioni
	var arrAnni = determinaAnniCompetizione(-1)
	var nAnni = arrAnni.length

	var nComp = arrAdOCompetizioni.length - 1
	var a, c, i, p, d
	var dettagliato

	// Genera una tabella per ogni coppia competizione/anno
	for (a = nAnni - 1; a >= 0; a--) {
		for (c = 1; c <= nComp; c++) {

			var tabD = new Tabella(2, 5)

			// Imposta propriet della tabella
			tabD.nome = "Dettagliato albo d'oro"
			tabD.larghezza = 100
			tabD.border = 0
			tabD.cellpadding = 1
			tabD.cellspacing = 0
			tabD.stile = "ClassEl"
			tabD.SetLarghezzaColonna(1, 30)
			tabD.SetLarghezzaColonna(2, 10)
			tabD.SetLarghezzaColonna(3, 10)
			tabD.SetLarghezzaColonna(4, 20)
			tabD.SetLarghezzaColonna(5, 30)

			// Imposta propriet del titolo (nome della competizione)
			tabD.SetStileRiga(1, "IntRossoBlu")
			tabD.SetSpan(1, 1, 5)
			tabD.SetSpanned(1, 2, true)
			tabD.SetSpanned(1, 3, true)
			tabD.SetSpanned(1, 4, true)
			tabD.SetSpanned(1, 5, true)
			tabD.SetValore(1, 1, arrAdOCompetizioni[c].nome + " (" + arrAnni[a] + " )")

			// Imposta stile e contenuto dell'header
			tabD.SetStileRiga(2, "IntRossoBlu")
			for (i = 1; i <= 5; i++)
				tabD.SetStile(2, i, "testo-cx")
			tabD.SetValore(2, 1, "Squadra")
			tabD.SetValore(2, 2, "Posizione")
			tabD.SetValore(2, 3, "Punti")
			tabD.SetValore(2, 4, "Presidente")
			tabD.SetValore(2, 5, "Note")

			// Calcola dettagliato della competizione
			dettagliato = new Array()
			for (p = 1; p < arrAdOPosizioni.length; p++)
				if (arrAdOPosizioni[p].idCompetizione == arrAdOCompetizioni[c].ID && arrAdOPosizioni[p].anno == arrAnni[a])
					dettagliato.push(arrAdOPosizioni[p]);
			if (dettagliato.length == 0) continue;
			// E lo ordina
			dettagliato.sort(ordina)

			// Riempie la tabella
			cnt = 3
			for (d = 0; d < dettagliato.length; d++) {
				// Imposta stile della riga
				tabD.SetStileRiga(cnt, (cnt % 2) == 0 ? "AlboD" : "AlboP")
				// Imposta stile e valore delle celle
				var idxF = mapFantasquadre[dettagliato[d].idSquadra]
				tabD.SetStile(cnt, 1, arrAdOFantasquadre[idxF].idAttuale == 0 ? "Cella" : "CellaBold")
				tabD.SetValore(cnt, 1,"<span class='" + (arrAdOFantasquadre[idxF].idAttuale == 0 ? "testo-blu" : "testo-blu-bold") + "'>" + arrAdOFantasquadre[idxF].nome + "</span>")
				tabD.SetStile(cnt, 2, "CellaCentro")
				tabD.SetValore(cnt, 2, dettagliato[d].posizione)
				tabD.SetStile(cnt, 3, "CellaCentro")
				tabD.SetValore(cnt, 3, dettagliato[d].punti)
				tabD.SetStile(cnt, 4, "Cella")
				tabD.SetValore(cnt, 4, dettagliato[d].presidente)
				tabD.SetStile(cnt, 5, "Cella")
				tabD.SetValore(cnt, 5, dettagliato[d].note)

				cnt++
			}
			// E la stampa
			tabD.Stampa()
			if (a != 0 || c != nComp) document.write("<br>")
		}
	}
}
